#include <math.h>
#include <stdio.h>
#include <graphics.h>

long int nr[4];

long int peg[4][201];

long int n0,v;

void cdisc(pegnr,discnr,col)
long int pegnr,discnr,col;
{
  double cb,dh,h,x;
  long int i,j,xi,hi,cbi,dhi;

  cb=60.0*(double)(n0+1-peg[pegnr][discnr])/(double)(n0);

  dh=200.0/(double)(n0+1);

  if (dh > 5.0) {
     dh=5.0;
  } /* if */

  h=11.0-dh+(2.0*dh+2.0)*(double)(discnr);
  x=200.0*(double)(pegnr)-90.0;

  xi=(int)(x+0.5);
  hi=460-(int)(h+0.5);
  cbi=(int)(cb+0.5);
  dhi=(int)(dh+0.5);

  for (i=xi-cbi; i<=xi+cbi; i++) {
     for (j=hi-dhi; j<=hi+dhi; j++) {
	 putpixel(i,j,col);
     } /* for j */
  } /* for i */

} /* cdisc */


void smod(fpeg,tpeg)
long int fpeg,tpeg;
{
   long int i;

   nr[tpeg]++;
   peg[tpeg][nr[tpeg]]=peg[fpeg][nr[fpeg]];
   cdisc(fpeg,nr[fpeg],0);
   cdisc(tpeg,nr[tpeg],4);
   nr[fpeg]--;
   for (i=1; i<=v; i++) ;

} /* smod */


void smd(fpeg,vpeg,tpeg,n)
long int fpeg,vpeg,tpeg;
long int n;
{
   if (n == 1) {
      smod(fpeg,tpeg);
   }
   else {
      smd(fpeg,tpeg,vpeg,n-1);
      smod(fpeg,tpeg);
      smd(vpeg,fpeg,tpeg,n-1);
   } /* if */
} /* smd */


void main()
{

   int gdriver=DETECT,gmode;

   long int i,j,n;
   long int fpeg,vpeg,tpeg;

   clrscr();
   printf("Towers of Hanoi\n\n");
   printf("Input n (9): ");
   scanf("%D",&n);
   printf("Input delay (0-1000) (100): ");
   scanf("%D",&v);
   clrscr();

   n0=n;
   v=v*10000;

   initgraph(&gdriver,&gmode,"");

   fpeg=1;
   vpeg=2;
   tpeg=3;

   for (i=1; i<=n; i++) {
      peg[fpeg][i]=i;
      cdisc(fpeg,i,4);
   } /* for i */


   for (i=10; i<=600; i++) {
      for (j=450; j<=460; j++) {
	 putpixel(i,j,9);
      } /* for j */
   } /* for i */

   getch();

   nr[fpeg]=n;
   nr[vpeg]=0;
   nr[tpeg]=0;


   smd(fpeg,vpeg,tpeg,n);

   getch();

   closegraph();

} /* End */
