/*** hill5.c  SS Oct 94 ***/

#include <math.h>
#include <stdio.h>
#include <graphics.h>

double pi=3.14159265358979323;

double sgn0(x)
double x;
{
   if (x >=0.0) {
      return(1.0);
   }
   else {
      return(-1.0);
   }
} /* sgn0 */

void main()
{
    int gdriver = DETECT,gmode;

    double vv,cv,sv,vh,ch,sh,f,f2,c,x,y,z,x1,y1,xs,ys,sgn,x0,y0,rrr,rr;
    long int i,j,r,k,ss,k2,flag,col,ii,ddd;
    int xx[1700];
    int yy[1700];


   clrscr();
   printf("HILL5\n\n");
   printf("Input angles vh,vv (0 - 90 degrees) (10 30): ");
   scanf("%lf %lf",&vh,&vv);
   printf("Input colour (1-15) (15): ");
   scanf("%D",&col);
   printf("Input delay (0-1000) (0): ");
   scanf("%D",&ddd);
   clrscr();

   ddd=10000*ddd;

   initgraph(&gdriver,&gmode, "");

   ch=cos(vh*pi/180); sh=sin(vh*pi/180);
   cv=cos(vv*pi/180); sv=sin(vv*pi/180);


   f=1000;
   f2=1.0/f;
   c=-2.0;
   r=20;
   x0=320;
   y0=250;
   ss=1;
   flag=1;

do {

for (k=-14; k<=14; k++) {

   sgn=0.05*ss*k;

   k2=1;

   for (j=-r; j<=r; j++) {
      for (i=-r; i<=r; i++) {
      x=(double)(4*i);
      y=(double)(4*j);
      rrr=sqrt(x*x+y*y);

      rr=4.0*(double)(r)-rrr;

      z=sgn*rr;

      xs=-c*(x*(f-y*cv)*f2*ch+y*sh)+x0;
      ys=c*(z*(f-y*ch)*f2*cv+y*sv)+y0;
      if (flag==0) {
	 putpixel(xx[k2],yy[k2],0);
      }
      putpixel((int)(xs),(int)(ys),col);
      xx[k2]=(int)(xs);
      yy[k2]=(int)(ys);
      k2=k2+1;

      } /* for i */
   } /* for j */

   for (ii=1; ii<=ddd; ii++);

   flag=0;

} /* for k */;

   if (ss==1) {
      ss=-1;
   }
   else {
      ss=1;
   }

} while (! kbhit());

   getch();

   closegraph();


} /* end */